Loading...
Searching...
No Matches
AVVulkanDeviceContext Struct Reference

Main Vulkan context, allocated as AVHWDeviceContext.hwctx. More...

`#include <libavutil/hwcontext_vulkan.h>`

## Data Fields

const VkAllocationCallbacks * | alloc
| Custom memory allocator, else NULL.
PFN_vkGetInstanceProcAddr | get_proc_addr
| Pointer to a vkGetInstanceProcAddr loading function.
VkInstance | inst
| Vulkan instance.
VkPhysicalDevice | phys_dev
| Physical device.
VkDevice | act_dev
| Active device.
VkPhysicalDeviceFeatures2 | device_features
| This structure should be set to the set of features that present and enabled during device creation.
const char *const * | enabled_inst_extensions
| Enabled instance extensions.
int | nb_enabled_inst_extensions
const char *const * | enabled_dev_extensions
| Enabled device extensions.
int | nb_enabled_dev_extensions
void(* | lock_queue )(struct AVHWDeviceContext *ctx, uint32_t queue_family, uint32_t index)
| Locks a queue, preventing other threads from submitting any command buffers to this queue.
void(* | unlock_queue )(struct AVHWDeviceContext *ctx, uint32_t queue_family, uint32_t index)
| Similar to lock_queue(), unlocks a queue.
AVVulkanDeviceQueueFamily | qf [64]
| Queue families used.
int | nb_qf

## Detailed Description

Main Vulkan context, allocated as AVHWDeviceContext.hwctx.

All of these can be set before init to change what the context uses

Definition at line 59 of file hwcontext_vulkan.h.

## Field Documentation

## alloc

const VkAllocationCallbacks* AVVulkanDeviceContext::alloc

Custom memory allocator, else NULL.

Definition at line 63 of file hwcontext_vulkan.h.

## get_proc_addr

PFN_vkGetInstanceProcAddr AVVulkanDeviceContext::get_proc_addr

Pointer to a vkGetInstanceProcAddr loading function.

If unset, will dynamically load and use libvulkan.

Definition at line 69 of file hwcontext_vulkan.h.

## inst

VkInstance AVVulkanDeviceContext::inst

Vulkan instance.

Must be at least version 1.3.

Definition at line 74 of file hwcontext_vulkan.h.

## phys_dev

VkPhysicalDevice AVVulkanDeviceContext::phys_dev

Physical device.

Definition at line 79 of file hwcontext_vulkan.h.

## act_dev

VkDevice AVVulkanDeviceContext::act_dev

Active device.

Definition at line 84 of file hwcontext_vulkan.h.

## device_features

VkPhysicalDeviceFeatures2 AVVulkanDeviceContext::device_features

This structure should be set to the set of features that present and enabled during device creation.

When a device is created by FFmpeg, it will default to enabling all that are present of the shaderImageGatherExtended, fragmentStoresAndAtomics, shaderInt64 and vertexPipelineStoresAndAtomics features.

Definition at line 92 of file hwcontext_vulkan.h.

## enabled_inst_extensions

const char* const* AVVulkanDeviceContext::enabled_inst_extensions

Enabled instance extensions.

If supplying your own device context, set this to an array of strings, with each entry containing the specified Vulkan extension string to enable. Duplicates are possible and accepted. If no extensions are enabled, set these fields to NULL, and 0 respectively.

Definition at line 101 of file hwcontext_vulkan.h.

## nb_enabled_inst_extensions

int AVVulkanDeviceContext::nb_enabled_inst_extensions

Definition at line 102 of file hwcontext_vulkan.h.

## enabled_dev_extensions

const char* const* AVVulkanDeviceContext::enabled_dev_extensions

Enabled device extensions.

By default, VK_KHR_external_memory_fd, VK_EXT_external_memory_dma_buf, VK_EXT_image_drm_format_modifier, VK_KHR_external_semaphore_fd and VK_EXT_external_memory_host are enabled if found. If supplying your own device context, these fields takes the same format as the above fields, with the same conditions that duplicates are possible and accepted, and that NULL and 0 respectively means no extensions are enabled.

Definition at line 112 of file hwcontext_vulkan.h.

## nb_enabled_dev_extensions

int AVVulkanDeviceContext::nb_enabled_dev_extensions

Definition at line 113 of file hwcontext_vulkan.h.

## lock_queue

void(* AVVulkanDeviceContext::lock_queue) (struct AVHWDeviceContext *ctx, uint32_t queue_family, uint32_t index)

Locks a queue, preventing other threads from submitting any command buffers to this queue.

If set to NULL, will be set to lavu-internal functions that utilize a mutex.

Definition at line 173 of file hwcontext_vulkan.h.

## unlock_queue

void(* AVVulkanDeviceContext::unlock_queue) (struct AVHWDeviceContext *ctx, uint32_t queue_family, uint32_t index)

Similar to lock_queue(), unlocks a queue.

Must only be called after locking.

Definition at line 178 of file hwcontext_vulkan.h.

## qf

AVVulkanDeviceQueueFamily AVVulkanDeviceContext::qf[64]

Queue families used.

Must be preferentially ordered. List may contain duplicates.

For compatibility reasons, all the enabled queue families listed above (queue_family_(tx/comp/encode/decode)_index) must also be included in this list until they're removed after deprecation.

Definition at line 188 of file hwcontext_vulkan.h.

## nb_qf

int AVVulkanDeviceContext::nb_qf

Definition at line 189 of file hwcontext_vulkan.h.

The documentation for this struct was generated from the following file:

- libavutil/hwcontext_vulkan.h